"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .atscompensation import AtsCompensation, AtsCompensationTypedDict
from datetime import datetime
from enum import Enum
from pydantic.functional_validators import PlainValidator
from typing import Any, Dict, List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict
from unified_python_sdk import utils
from unified_python_sdk.types import BaseModel
from unified_python_sdk.utils import validate_open_enum


class AtsOfferStatus(str, Enum, metaclass=utils.OpenEnumMeta):
    CREATED = "CREATED"
    SENT = "SENT"
    ACCEPTED = "ACCEPTED"
    REJECTED = "REJECTED"


class AtsOfferTypedDict(TypedDict):
    accepted_at: NotRequired[datetime]
    compensation: NotRequired[List[AtsCompensationTypedDict]]
    r"""compensation details for the offer"""
    created_at: NotRequired[datetime]
    creator_user_id: NotRequired[str]
    employee_user_id: NotRequired[str]
    id: NotRequired[str]
    raw: NotRequired[Dict[str, Any]]
    rejected_at: NotRequired[datetime]
    sent_at: NotRequired[datetime]
    start_at: NotRequired[datetime]
    status: NotRequired[AtsOfferStatus]
    updated_at: NotRequired[datetime]


class AtsOffer(BaseModel):
    accepted_at: Optional[datetime] = None

    compensation: Optional[List[AtsCompensation]] = None
    r"""compensation details for the offer"""

    created_at: Optional[datetime] = None

    creator_user_id: Optional[str] = None

    employee_user_id: Optional[str] = None

    id: Optional[str] = None

    raw: Optional[Dict[str, Any]] = None

    rejected_at: Optional[datetime] = None

    sent_at: Optional[datetime] = None

    start_at: Optional[datetime] = None

    status: Annotated[
        Optional[AtsOfferStatus], PlainValidator(validate_open_enum(False))
    ] = None

    updated_at: Optional[datetime] = None
