"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .calendarattachment import CalendarAttachment, CalendarAttachmentTypedDict
from .calendarattendee import CalendarAttendee, CalendarAttendeeTypedDict
from .calendarconference import CalendarConference, CalendarConferenceTypedDict
from .calendareventrecurrence import (
    CalendarEventRecurrence,
    CalendarEventRecurrenceTypedDict,
)
from .property_calendarevent_organizer import (
    PropertyCalendarEventOrganizer,
    PropertyCalendarEventOrganizerTypedDict,
)
from enum import Enum
from pydantic.functional_validators import PlainValidator
from typing import Any, Dict, List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict
from unified_python_sdk import utils
from unified_python_sdk.types import BaseModel
from unified_python_sdk.utils import validate_open_enum


class CalendarEventStatus(str, Enum, metaclass=utils.OpenEnumMeta):
    CANCELED = "CANCELED"
    CONFIRMED = "CONFIRMED"
    TENTATIVE = "TENTATIVE"


class CalendarEventTypedDict(TypedDict):
    attachments: NotRequired[List[CalendarAttachmentTypedDict]]
    attendees: NotRequired[List[CalendarAttendeeTypedDict]]
    calendar_id: NotRequired[str]
    conference: NotRequired[List[CalendarConferenceTypedDict]]
    created_at: NotRequired[str]
    end_at: NotRequired[str]
    has_conference: NotRequired[bool]
    id: NotRequired[str]
    is_all_day: NotRequired[bool]
    is_free: NotRequired[bool]
    is_private: NotRequired[bool]
    location: NotRequired[str]
    notes: NotRequired[str]
    organizer: NotRequired[PropertyCalendarEventOrganizerTypedDict]
    raw: NotRequired[Dict[str, Any]]
    recurrence: NotRequired[List[CalendarEventRecurrenceTypedDict]]
    recurring_event_id: NotRequired[str]
    start_at: NotRequired[str]
    status: NotRequired[CalendarEventStatus]
    subject: NotRequired[str]
    timezone: NotRequired[str]
    updated_at: NotRequired[str]
    web_url: NotRequired[str]


class CalendarEvent(BaseModel):
    attachments: Optional[List[CalendarAttachment]] = None

    attendees: Optional[List[CalendarAttendee]] = None

    calendar_id: Optional[str] = None

    conference: Optional[List[CalendarConference]] = None

    created_at: Optional[str] = None

    end_at: Optional[str] = None

    has_conference: Optional[bool] = None

    id: Optional[str] = None

    is_all_day: Optional[bool] = None

    is_free: Optional[bool] = None

    is_private: Optional[bool] = None

    location: Optional[str] = None

    notes: Optional[str] = None

    organizer: Optional[PropertyCalendarEventOrganizer] = None

    raw: Optional[Dict[str, Any]] = None

    recurrence: Optional[List[CalendarEventRecurrence]] = None

    recurring_event_id: Optional[str] = None

    start_at: Optional[str] = None

    status: Annotated[
        Optional[CalendarEventStatus], PlainValidator(validate_open_enum(False))
    ] = None

    subject: Optional[str] = None

    timezone: Optional[str] = None

    updated_at: Optional[str] = None

    web_url: Optional[str] = None
