"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from enum import Enum
from pydantic.functional_validators import PlainValidator
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict
from unified_python_sdk import utils
from unified_python_sdk.types import BaseModel
from unified_python_sdk.utils import validate_open_enum


class IssueStatus(str, Enum, metaclass=utils.OpenEnumMeta):
    COMPLETED = "COMPLETED"
    NEW = "NEW"
    ROADMAP = "ROADMAP"
    IN_PROGRESS = "IN_PROGRESS"
    ON_HOLD = "ON_HOLD"
    VALIDATING = "VALIDATING"
    REJECTED = "REJECTED"


class IssueTypedDict(TypedDict):
    status: IssueStatus
    ticket_ref: str
    title: str
    workspace_id: str
    created_at: NotRequired[str]
    id: NotRequired[str]
    importance: NotRequired[float]
    resolution_time: NotRequired[float]
    size: NotRequired[float]
    type: NotRequired[List[str]]
    updated_at: NotRequired[str]
    url: NotRequired[str]


class Issue(BaseModel):
    status: Annotated[IssueStatus, PlainValidator(validate_open_enum(False))]

    ticket_ref: str

    title: str

    workspace_id: str

    created_at: Optional[str] = None

    id: Optional[str] = None

    importance: Optional[float] = None

    resolution_time: Optional[float] = None

    size: Optional[float] = None

    type: Optional[List[str]] = None

    updated_at: Optional[str] = None

    url: Optional[str] = None
